INCDIR = -I$(HDFINC) -I$(HDF5INC) -I$(HDFEOS5_INC)
LIBDIR = -L$(HDFLIB) -L$(HDF5LIB) -L$(HDFEOS5_LIB) -lhe5_hdfeos -lGctp $(HDF5LIB)/libhdf5_hl.a $(HDF5LIB)/libhdf5.a -ljpeg -lz $(SZIPLIB)/libsz.a -lm

default all:
	@if [ $(BRAND) = "sgi64" ] || [ $(BRAND) = "linux64" ] ; then \
	echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in swath directory ----"; \
	cd swath; \
	$(CC) $(CFLAGS) -o TestSwath.o $(INCDIR) -c TestSwath.c; \
	$(CC) $(CFLAGS) -o TestSwath_c TestSwath.o $(LIBDIR) $(CEXTRAL); \
	$(CC) $(CFLAGS) -o TestProfile.o $(INCDIR) -c TestProfile.c; \
	$(CC) $(CFLAGS) -o TestProfile_c TestProfile.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testswath64.o $(INCDIR) -c testswath64.f; \
	$(F77) $(FFLAGS) -o testswath64_f testswath64.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in grid directory ----"; \
	cd ../grid; $(CC) $(CFLAGS) -o TestGrid.o $(INCDIR) -c TestGrid.c; \
	$(CC) $(CFLAGS) -o TestGrid_c TestGrid.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testgrid64.o $(INCDIR) -c testgrid64.f; \
	$(F77) $(FFLAGS) -o testgrid64_f testgrid64.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in point directory ----"; \
	cd ../point; $(CC) $(CFLAGS) -o TestPoint.o $(INCDIR) -c TestPoint.c; \
	$(CC) $(CFLAGS) -o TestPoint_c TestPoint.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testpoint64.o $(INCDIR) -c testpoint64.f; \
	$(F77) $(FFLAGS) -o testpoint64_f testpoint64.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o;echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in za directory ----"; \
	cd ../za; $(CC) $(CFLAGS) -o TestZa.o $(INCDIR) -c TestZa.c; \
	$(CC) $(CFLAGS) -o TestAlias.o $(INCDIR) -c TestAlias.c; \
	$(CC) $(CFLAGS) -o TestZa_c TestZa.o $(LIBDIR) $(CEXTRAL); \
	$(CC) $(CFLAGS) -o TestAlias_c TestAlias.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testza64.o $(INCDIR) -c testza64.f; \
	$(F77) $(FFLAGS) -o testza64_f testza64.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	else \
	echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in swath directory ----"; \
	cd swath; \
	$(CC) $(CFLAGS) -o TestSwath.o $(INCDIR) -c TestSwath.c; \
	$(CC) $(CFLAGS) -o TestSwath_c TestSwath.o $(LIBDIR) $(CEXTRAL); \
	$(CC) $(CFLAGS) -o TestProfile.o $(INCDIR) -c TestProfile.c; \
	$(CC) $(CFLAGS) -o TestProfile_c TestProfile.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testswath32.o $(INCDIR) -c testswath32.f; \
	$(F77) $(FFLAGS) -o testswath32_f testswath32.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in grid directory ----"; \
	cd ../grid; $(CC) $(CFLAGS) -o TestGrid.o $(INCDIR) -c TestGrid.c; \
	$(CC) $(CFLAGS) -o TestGrid_c TestGrid.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testgrid32.o $(INCDIR) -c testgrid32.f; \
	$(F77) $(FFLAGS) -o testgrid32_f testgrid32.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in point directory ----"; \
	cd ../point; $(CC) $(CFLAGS) -o TestPoint.o $(INCDIR) -c TestPoint.c; \
	$(CC) $(CFLAGS) -o TestPoint_c TestPoint.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testpoint32.o $(INCDIR) -c testpoint32.f; \
	$(F77) $(FFLAGS) -o testpoint32_f testpoint32.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o;echo " "; echo " "; \
	echo " ---- Making *.c and *.f testdrivers in za directory ----"; \
	cd ../za; $(CC) $(CFLAGS) -o TestZa.o $(INCDIR) -c TestZa.c; \
	$(CC) $(CFLAGS) -o TestAlias.o $(INCDIR) -c TestAlias.c; \
	$(CC) $(CFLAGS) -o TestZa_c TestZa.o $(LIBDIR) $(CEXTRAL); \
	$(CC) $(CFLAGS) -o TestAlias_c TestAlias.o $(LIBDIR) $(CEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	$(F77) $(FFLAGS) -o testza32.o $(INCDIR) -c testza32.f; \
	$(F77) $(FFLAGS) -o testza32_f testza32.o $(LIBDIR) $(FEXTRAL); \
	$(RM) $(RMFLAGS) *.o; \
	fi ; 
